//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TDeleteProjectDialog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDeleteProjectDialog *DeleteProjectDialog;
//---------------------------------------------------------------------------
__fastcall TDeleteProjectDialog::TDeleteProjectDialog(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TDeleteProjectDialog::FormShow(TObject *Sender)
{
  UpdateAliases();
}
//---------------------------------------------------------------------------
void __fastcall TDeleteProjectDialog::cbAliasesChange(TObject *Sender)
{
  TStringList* Params = new TStringList();
  Session->GetAliasParams(cbAliases->Text, Params);
  String WD = Params->Strings[0];
  WD.Delete(1, 5);
  WD = IncludeTrailingBackslash(WD);
  dlbWorkingDirectory->Directory = WD;
  delete Params;

}
//---------------------------------------------------------------------------

void __fastcall TDeleteProjectDialog::bDeleteProjectClick(TObject *Sender)
{
  if (!rbNameOnly->Checked) {
    String s = String("Warning - all files in the directory\n")
               + lWorkingDirectory->Caption
               + String("\nwill be deleted.  Is this OK?");
    int result = MessageDlg(s, mtWarning, TMsgDlgButtons() << mbYes << mbNo, 0);
    if (result == mrYes) {
      for (int i = 0; i < flbFiles->Items->Count; i++) {
        String file = IncludeTrailingBackslash(dlbWorkingDirectory->Directory)
                      + flbFiles->Items->Strings[i];
        DeleteFile(file);
      }
      flbFiles->Update();
    }
    /* DONE : Delete DAT files */
    String SaveProjectPath = dlbWorkingDirectory->Directory;
    String DATPath = IncludeTrailingBackslash(dlbWorkingDirectory->Directory) + String("dat\\");
    if (DirectoryExists(DATPath)) {
      dlbWorkingDirectory->Directory = DATPath;
      for (int i = 0; i < flbFiles->Items->Count; i++) {
        String file = DATPath + flbFiles->Items->Strings[i];
        DeleteFile(file);
      }
    /* DONE : Delete directories */
      SetCurrentDir(ExtractFilePath(Application->ExeName));
      if (rbAll->Checked) RemoveDir(DATPath);
    }
    if (rbAll->Checked) RemoveDir(SaveProjectPath);
  }
  else {
    String s = String("Warning - the Project alias:\n")
               + lWorkingDirectory->Caption
               + String("\nwill be deleted.  Is this OK?");
    int result = MessageDlg(s, mtWarning, TMsgDlgButtons() << mbYes << mbNo, 0);
    if (result != mrYes) return;
  }
  Session->DeleteAlias(cbAliases->Text);
  Session->SaveConfigFile();
  UpdateAliases();
}
//---------------------------------------------------------------------------

void TDeleteProjectDialog::UpdateAliases()
{
  TStringList* AliasNames = new TStringList();
  Session->GetAliasNames(AliasNames);
  cbAliases->Items->Clear();
  for (int i=0; i<AliasNames->Count; i++) {
    if (Session->GetAliasDriverName(AliasNames->Strings[i]) == String("STANDARD")) {
      TStringList* TableNames = new TStringList();
      String Pattern = "";
      Session->GetTableNames(AliasNames->Strings[i], Pattern, true, false, TableNames);
      bool IsEFSEditorAlias = false;
      for (int i=0; i<TableNames->Count; i++) {
        if (TableNames->Strings[i].UpperCase() == String("JumpRoutes.db").UpperCase()) {
          IsEFSEditorAlias = true;
        }
      }
      if (IsEFSEditorAlias) cbAliases->Items->Add(AliasNames->Strings[i]);
      delete TableNames;
    }
  }
  delete AliasNames;
  cbAliases->ItemIndex = 0;
  cbAliasesChange(this);
}
