//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TEFSCStructure.h"
#include "TEFSCGalaxy.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
TEFSCStructure::TEFSCStructure() {

  TempCount = 0;
  TempCount2 = 0;
  TempCount3 = 0;
  Damage = 0;
  
}
//---------------------------------------------------------------------------

TEFSCStructure::~TEFSCStructure() {

}
//---------------------------------------------------------------------------

int TEFSCStructure::Save(ofstream* outfile) {

  outfile->write((char*)&FPIdx, sizeof(FPIdx));
  outfile->write((char*)&Fx, sizeof(Fx));
  outfile->write((char*)&Fy, sizeof(Fy));

  outfile->write((char*)&Type, sizeof(Type));
  outfile->write((char*)&Owner, sizeof(Owner));
  outfile->write((char*)&PrevOwner, sizeof(PrevOwner));

  outfile->write((char*)&ProdRuinType, sizeof(ProdRuinType));
  outfile->write((char*)&ProdInfo, sizeof(ProdInfo));
  outfile->write((char*)&TurnsLeft, sizeof(TurnsLeft));
  outfile->write((char*)&CityInfo, sizeof(CityInfo));
  outfile->write((char*)&PrevType, sizeof(PrevType));
  outfile->write((char*)&UnitLoyalty, sizeof(UnitLoyalty));

  outfile->write((char*)&FLoyalty, sizeof(FLoyalty));

  outfile->write((char*)&StackInfo, sizeof(StackInfo));
  outfile->write((char*)&UsedUnittLvl, sizeof(UsedUnittLvl));

  outfile->write((char*)&TechType, sizeof(TechType));

  outfile->write((char*)&Health, sizeof(Health));
  outfile->write((char*)&Sect, sizeof(Sect));
  outfile->write((char*)&Flags, sizeof(Flags));

  return true;
}
//---------------------------------------------------------------------------

int TEFSCStructure::Load(ifstream* infile, bool saveGame, int saveVersion, int origVersion) {

  infile->read((char*)&Type, sizeof(Type));
  infile->read((char*)&Owner, sizeof(Owner));
  infile->read((char*)&PrevOwner, sizeof(PrevOwner));

  infile->read((char*)&ProdRuinType, sizeof(ProdRuinType));
  infile->read((char*)&ProdInfo, sizeof(ProdInfo));
  infile->read((char*)&TurnsLeft, sizeof(TurnsLeft));
  infile->read((char*)&CityInfo, sizeof(CityInfo));
  infile->read((char*)&PrevType, sizeof(PrevType));
  infile->read((char*)&UnitLoyalty, sizeof(UnitLoyalty));

  if (origVersion >= 961006) {
    short loyalty;
    infile->read((char*)&loyalty, sizeof(loyalty));
    SetLoyalty(loyalty);
  }
  else SetLoyalty(75);

  infile->read((char*)&StackInfo, sizeof(StackInfo));
  infile->read((char*)&UsedUnittLvl, sizeof(UsedUnittLvl));
  if (origVersion >= 961125) {
    infile->read((char*)&TechType, sizeof(TechType));
  }
  else TechType = -1;

  infile->read((char*)&Health, sizeof(Health));
  infile->read((char*)&Sect, sizeof(Sect));
  infile->read((char*)&Flags, sizeof(Flags));

  if (Owner == IMPERIAL) {
    PrevOwner = IMPERIAL;
  }
  else if (Owner == FLEET) {
    PrevOwner = FLEET;
  }
  else if (Owner == STIGMATA) {
    PrevOwner = STIGMATA;
  }
  else if (Owner == THE_SPY) {
    PrevOwner = THE_SPY;
  }

  // Code to clean up save game data that may have been corrupted
  //by old bugs:
  if ((PrevOwner < FLEET) || (PrevOwner > THE_SPY)) {
    PrevOwner = Owner;
    Flags &= ~CITY_ON_LOAN;
  }

  return true;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
