//---------------------------------------------------------------------------
#ifndef TEFSCStructureH
#define TEFSCStructureH


#include <fstream.h>
//---------------------------------------------------------------------------

const UINT CITY_STARVING          = 0x0008;
const UINT CITY_HAS_PLAGUE        = 0x0008;
const UINT CITY_MIGHT_HAVE_PLAGUE = 0x0008;
const UINT CITY_ON_LOAN           = 0x0008;
const UINT CITY_NO_PROD           = 0x0008;
const UINT CITY_DESTROYED         = 0x0008;

class TEFSCStructure {
private:
  short FPIdx;      // Planet index of this structure's location
  short Fx, Fy;     // Coordinates of this structure's location;
                    //the hex coordinates if on the planet surface
  short FLoyalty;   // City Loyalty, as a percent

protected:

public:
  short Type;       // Index into the Structure Table containing this city's characteristics
  short Owner;      // Faction to which this city belongs
  short PrevOwner;  // Faction to which this city normally belongs
  union {           // From Holistic code:
    short ProdType; //  "unit type being built"
    short RuinType; //  "tech, units, resources"
  } ProdRuinType;
  union {           // From Holistic code:
    short ProdtLvl; //  "unit tLvl being built"
    short RuinWhat; //  "what tech, what unit type, what resource"
  } ProdInfo;
  short TurnsLeft;  // Number of turns until current production is complete
  union {                   // From Holistic code:
    short ResPoints;        //  "for Labs"
    short RuinAmount;       //  "amount of resource, number of unit"
    short HiveProdPhase;    //  "symbiot hives"
  } CityInfo;
  short PrevType;           // Unknown
  short UnitLoyalty;        // Loyalty of units produced in this city?
  union {                   // From Holistic code:
    short UsedUnitType;     // ""
    short RuinStack;        // "which stack profile to bring up"
  } StackInfo;
  short UsedUnittLvl;
  short TechType;
  short Health;
  short Sect;
  UINT  Flags;
  short UnitHealth; // (Saved) "health of unit that was absorbed for building"

  short TempCount;  // (Not saved) "AI variable"
  short TempCount2; // (Not saved) "AI variable"
  short TempCount3; // (Not saved) "AI variable"

  short Damage;     // (Not saved)  

  TEFSCStructure();
  ~TEFSCStructure();

  void SetPosition(short pIdx, short x, short y)
    { FPIdx = pIdx; Fx = x; Fy = y; }
  short X() { return Fx; }
  short Y() { return Fy; }
  short PIdx() { return FPIdx; }

  void SetLoyalty(int loyalty) { FLoyalty = loyalty; }
  short Loyalty() { return FLoyalty; }

  int Save(ofstream* outfile);
  int Load(ifstream* infile, bool saveGame, int saveVersion, int origVersion);
 
};

//---------------------------------------------------------------------------
#endif
