//---------------------------------------------------------------------------
#ifndef TEFSMainH
#define TEFSMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ActnList.hpp>
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>

#include "TEFSCGalaxy.h"
#include <StdActns.hpp>
#include <DBActns.hpp>

const int PROGRESS_PANEL = 0;
const int STATUS_PANEL = 1;
const int HINT_PANEL = 2;
const int FUTURE_PANEL = 3;

//---------------------------------------------------------------------------
class TEFSMain : public TForm
{
__published:	// IDE-managed Components
  TMainMenu *EFSMainMenu;
  TActionList *EFSMainActions;
  TImageList *ESFMainCommandImages;
  TToolBar *EFSMainToolBar;
  TMenuItem *FileMenu;
  TMenuItem *FileNew;
  TAction *FileNewAction;
  TAction *FileOpenAction;
  TAction *FileCloseAllAction;
  TMenuItem *FileOpen;
  TMenuItem *FileCloseAll;
  TStatusBar *EFSMainStatusBar;
  TOpenDialog *OpenEFSCGALDlg;
  TAction *FileExportAction;
  TMenuItem *FileSaveAction1;
  TAction *FileCopyAction;
  TMenuItem *SaveAs1;
  TAction *ViewJumpGateListAction;
  TMenuItem *ViewMenu;
  TMenuItem *JumpGateList1;
  TAction *ViewStarMapAction;
  TMenuItem *ViewStarMapAction1;
  TToolButton *ToolButton1;
  TToolButton *ToolButton2;
  TEditCut *EditCutAction;
  TEditCopy *EditCopyAction;
  TEditPaste *EditPasteAction;
  TMenuItem *EditMenu;
  TMenuItem *EditCut;
  TMenuItem *EditCopy;
  TMenuItem *EditPaste;
  TToolButton *ToolButton3;
  TToolButton *ToolButton5;
  TToolButton *ToolButton6;
  TToolButton *ToolButton7;
  TToolButton *ToolButton8;
  TAction *ZoomInAction;
  TAction *ZoomOutAction;
  TToolButton *ToolButton10;
  TToolButton *ToolButton11;
  TMenuItem *N1;
  TMenuItem *ViewZoomIn;
  TMenuItem *ViewZoomOut;
  TToolButton *ToolButton12;
  TMenuItem *N2;
  TAction *ViewGalaxyStatsAction;
  TMenuItem *ViewOptions1;
  TAction *ViewPlanetListAction;
  TMenuItem *PlanetList1;
  TAction *ViewUnitListAction;
  TMenuItem *UnitList1;
  TAction *ViewStructureListAction;
  TMenuItem *StructureList1;
  TMenuItem *ToolsMenu;
  TMenuItem *HelpMenu;
  TMenuItem *DataMenu;
  TAction *DataFactionsAction;
  TMenuItem *Factions1;
  TAction *DataSectsAction;
  TMenuItem *Sects1;
  TMenuItem *DataEditDAT;
  TAction *EditUnitDATAction;
  TMenuItem *UNITDAT1;
  TAction *EditStrbuildDATAction;
  TMenuItem *STRBUILDDAT1;
  TAction *DataEditEFSINIAction;
  TMenuItem *EditEFSINI1;
  TAction *EditTechDATAction;
  TMenuItem *TECHDAT1;
  TAction *DataPlanetTypeAction;
  TMenuItem *PlanetTypes1;
  TAction *EditAgilityDATAction;
  TAction *EditArboriumDATAction;
  TAction *EditDamageDATAction;
  TAction *EditFarmDATAction;
  TAction *EditMineDATAction;
  TAction *EditProdDATAction;
  TAction *EditProfileDATAction;
  TAction *EditRelicsDATAction;
  TAction *EditResDATAction;
  TAction *EditRoadcostDATAction;
  TAction *EditStockDATAction;
  TAction *EditTargetDATAction;
  TAction *EditTercolorDATAction;
  TAction *EditTraitsDATAction;
  TAction *EditUnitrulzDATAction;
  TAction *EditUnitspotDATAction;
  TAction *EditWellDATAction;
  TMenuItem *WELLDAT1;
  TMenuItem *UNITSPOTDAT1;
  TMenuItem *UNITRULZDAT1;
  TMenuItem *TRAITSDAT1;
  TMenuItem *Factions2;
  TMenuItem *TARGETDAT1;
  TMenuItem *STOCKDAT1;
  TMenuItem *ROADCOSTDAT1;
  TMenuItem *RESDAT1;
  TMenuItem *RELICSDAT1;
  TMenuItem *PROFILEDAT1;
  TMenuItem *PRODDAT1;
  TMenuItem *MINEDAT1;
  TMenuItem *FARMDAT1;
  TMenuItem *DAMAGEDAT1;
  TMenuItem *ARBORIUMDAT1;
  TMenuItem *AGILITYDAT1;
  TMenuItem *Window1;
  TMenuItem *TileVertically1;
  TMenuItem *TileHorizontally1;
  TMenuItem *Cascade1;
  TMenuItem *MinimizeAll1;
  TMenuItem *Close1;
  TMenuItem *Arrange1;
  TMenuItem *N3;
  TSaveDialog *SaveEFSCGALDlg;
  TActionList *DatabaseActions;
  TImageList *DatabaseCommandImages;
  TDataSetCancel *DataSetCancel1;
  TDataSetDelete *DataSetDelete1;
  TDataSetEdit *DataSetEdit1;
  TDataSetFirst *DataSetFirst1;
  TDataSetInsert *DataSetInsert1;
  TDataSetLast *DataSetLast1;
  TDataSetNext *DataSetNext1;
  TDataSetPost *DataSetPost1;
  TDataSetPrior *DataSetPrior1;
  TDataSetRefresh *DataSetRefresh1;
  TWindowArrange *WindowArrange1;
  TWindowCascade *WindowCascade1;
  TWindowClose *WindowClose1;
  TWindowMinimizeAll *WindowMinimizeAll1;
  TWindowTileHorizontal *WindowTileHorizontal1;
  TWindowTileVertical *WindowTileVertical1;
  TToolButton *ToolButton13;
  TCoolBar *CoolBar1;
  TToolBar *DatabaseToolBar;
  TToolButton *ToolButton14;
  TToolButton *ToolButton15;
  TToolButton *ToolButton16;
  TToolButton *ToolButton17;
  TToolButton *ToolButton18;
  TToolButton *ToolButton19;
  TToolButton *ToolButton4;
  TToolButton *ToolButton27;
  TToolButton *ToolButton28;
  TAction *ExchangeUnitTypesAction;
  TMenuItem *SwapUnitTypes1;
  TAction *ImportDATFileSetAction;
  TMenuItem *ImportDATFileSet1;
  THelpContents *HelpContentsAction;
  THelpTopicSearch *HelpTopicSearchAction;
  THelpOnHelp *HelpOnHelpAction;
  TAction *HelpAboutAction;
  TMenuItem *Contents1;
  TMenuItem *TopicSearch1;
  TMenuItem *N4;
  TMenuItem *N5;
  TMenuItem *HelponHelp1;
  TMenuItem *HelpAboutAction1;
  TMenuItem *N6;
  TAction *ExitAction;
  TMenuItem *N7;
  TAction *DeleteProjectAction;
  TMenuItem *DeleteProject1;
  TMenuItem *Exit1;
  TAction *DATGridViewAction;
  TMenuItem *DATGridViewAction1;
  void __fastcall FileExportActionExecute(TObject *Sender);
  void __fastcall ViewJumpGateListActionExecute(TObject *Sender);
  void __fastcall ViewStarMapActionExecute(TObject *Sender);
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall EFSMainStatusBarDrawPanel(TStatusBar *StatusBar,
          TStatusPanel *Panel, const TRect &Rect);
  void __fastcall ViewGalaxyStatsActionExecute(TObject *Sender);
  void __fastcall ViewPlanetListActionExecute(TObject *Sender);
  void __fastcall ViewUnitListActionExecute(TObject *Sender);
  void __fastcall ViewStructureListActionExecute(TObject *Sender);
  void __fastcall DataFactionsActionExecute(TObject *Sender);
  void __fastcall EditDATText(TObject *Sender);
  void __fastcall DataPlanetTypeActionExecute(TObject *Sender);
  void __fastcall DataSectsActionExecute(TObject *Sender);
  void __fastcall FileNewActionExecute(TObject *Sender);
  void __fastcall FileOpenActionExecute(TObject *Sender);
  void __fastcall ImportDATFileSetActionExecute(TObject *Sender);
  void __fastcall HelpAboutActionExecute(TObject *Sender);
  void __fastcall FileCloseAllActionExecute(TObject *Sender);
  void __fastcall DeleteProjectActionExecute(TObject *Sender);
  void __fastcall DATGridViewActionExecute(TObject *Sender);
  void __fastcall ToolsMenuClick(TObject *Sender);
  void __fastcall ExchangeUnitTypesActionExecute(TObject *Sender);
private:	// User declarations
  TEFSCGalaxy* EFSCGalaxy;

  int Progress;

public:		// User declarations
  String LastEFSCGalaxyFileName;
  String LastEFSCGalaxyPathName;
  String LastDATPath;
  String CurrentAliasName;
  String TemplateAliasName;

  __fastcall TEFSMain(TComponent* Owner);
  void __fastcall OnHint(TObject* Sender);
  void ShowProgress(int progress);
  void StatusMessage(String message);
  void UpdateViews();

};
//---------------------------------------------------------------------------
extern PACKAGE TEFSMain *EFSMain;
//---------------------------------------------------------------------------
#endif
