//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TGalaxyModule.h"
#include "TEFSCUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "StrBuildProcessor"
#pragma link "TBasicGalaxyModule"
#pragma link "TechDatProcessor"
#pragma link "UnitProcessor"
#pragma link "DamageProcessor"
#pragma link "ProdDatProcessor"
#pragma link "STCRCProcessor"
#pragma link "TargetProcessor"
#pragma link "HarvestDataProcessor"
#pragma link "USTCProcessor"
#pragma link "ResDatProcessor"
#pragma resource "*.dfm"
TGalaxyModule *GalaxyModule;
//---------------------------------------------------------------------------
__fastcall TGalaxyModule::TGalaxyModule(TComponent* Owner)
  : TBasicGalaxyModule(Owner)
{
  ActivateAllTables();  
}
//---------------------------------------------------------------------------
void __fastcall TGalaxyModule::UnitTableCalcFields(TDataSet *DataSet)
{
  switch (UnitTableExperience->AsInteger)
  {
    case 0 : UnitTableExpText->AsString = "Gr";
    break;
    case 1 : UnitTableExpText->AsString = "Ex";
    break;
    case 2 : UnitTableExpText->AsString = "El";
    break;
  }
  UnitTableMPText->AsString = UnitTableMovePoints->AsString + String("/")
                              + UnitTableMovePointsLU->AsString;
  UnitTableCamoText->AsString = UnitTableCamo->AsString + String("/")
                                + UnitTableCamoLU->AsString;
  UnitTableHealthText->AsString = UnitTableExpText->AsString + String(" L:")
                                  + UnitTableLoyalty->AsString + String(" H:")
                                  + UnitTableHealth->AsString;
  if (UnitTableAmount->AsInteger >=0) {
    UnitTableNameText->AsString = UnitTableShortOwnerLU->AsString + String(" - ")
                                  + UnitTableTypeLU->AsString + String(" (")
                                  + UnitTableAmount->AsString + String(" ")
                                  + UnitTableResRelicLU->AsString + String(")");
  }
  else {
    UnitTableNameText->AsString = UnitTableShortOwnerLU->AsString + String(" - ")
                                  + UnitTableTypeLU->AsString + String(" (")
                                  + UnitTableHealthText->AsString + String(")");
  }
  UnitTableNameText->AsString = UnitTableShortOwnerLU->AsString + String(" - ")
                                + UnitTableTypeLU->AsString + String(" (")
                                + UnitTableHealthText->AsString + String(")");
  if (UnitTableFlags->AsInteger & UNIT_ON_PLANET) {
    UnitTableLocText->AsString = UnitTablePlanetLU->AsString + String(" (")
                                + UnitTableX->AsString + String(",")
                                + UnitTableY->AsString + String(")");
  }
  else {
    UnitTableLocText->AsString = UnitTablePlanetLU->AsString + String(" (Space)");
  }
  UnitTableMoveText->AsString = UnitTableMoveTypeLU->AsString + String(" ")
                                + String(" (")
                                + UnitTableMPText->AsString + String(")");
}
//---------------------------------------------------------------------------

bool TGalaxyModule::LoadDATFiles(String datPath)
{
  ResProcessor->DataTableName = ResDAT;
  ResProcessor->DatFileName = datPath + String("res.dat");
  ResProcessor->ProcessTextFile();
  ResDAT->Active = true;

  UnitProcessor->DataTableName = UnitDAT;
  UnitProcessor->DatFileName = datPath + String("unit.dat");
  UnitProcessor->ProcessTextFile();
  UnitDAT->Active = true;

  StrBuildProcessor->DataTableName = StructureDAT;
  StrBuildProcessor->DatFileName = datPath + String("strbuild.dat");
  StrBuildProcessor->ProcessTextFile();
  StructureDAT->Active = true;

  TechDatProcessor->DataTableName = TechDAT;
  TechDatProcessor->DatFileName = datPath + String("tech.dat");
  TechDatProcessor->ProcessTextFile();
  TechDAT->Active = true;

  DamageProcessor->DataTableName = DamageDAT;
  DamageProcessor->DamageFileName = datPath + String("damage.dat");
  DamageProcessor->ProcessTextFile();
  DamageDAT->Active = true;

  TargetProcessor->DataTableName = TargetDAT;
  TargetProcessor->DatFileName = datPath + String("target.dat");
  TargetProcessor->ProcessTextFile();
  TargetDAT->Active = true;

  StockProcessor->DataTableName = StockDAT;
  StockProcessor->DatFileName = datPath + String("stock.dat");
  StockProcessor->ProcessTextFile();
  StockDAT->Active = true;

  TerColorProcessor->DataTableName = TerColorDAT;
  TerColorProcessor->DatFileName = datPath + String("tercolor.dat");
  TerColorProcessor->ProcessTextFile();
  TerColorDAT->Active = true;

  RoadCostProcessor->DataTableName = RoadCostDAT;
  RoadCostProcessor->DatFileName = datPath + String("roadcost.dat");
  RoadCostProcessor->ProcessTextFile();
  RoadCostDAT->Active = true;

  ProdProcessor->DataTableName = ProdDAT;
  ProdProcessor->DatFileName = datPath + String("prod.dat");
  ProdProcessor->ProcessTextFile();
  ProdDAT->Active = true;

  HarvestProcessor->DataTableName = ArboriumDAT;
  HarvestProcessor->HarvestDatFileName = datPath + String("arborium.dat");
  HarvestProcessor->ProcessTextFile();
  ArboriumDAT->Active = true;

  HarvestProcessor->DataTableName = FarmDAT;
  HarvestProcessor->HarvestDatFileName = datPath + String("farm.dat");
  HarvestProcessor->ProcessTextFile();
  FarmDAT->Active = true;

  HarvestProcessor->DataTableName = MineDAT;
  HarvestProcessor->HarvestDatFileName = datPath + String("mine.dat");
  HarvestProcessor->ProcessTextFile();
  MineDAT->Active = true;

  HarvestProcessor->DataTableName = WellDAT;
  HarvestProcessor->HarvestDatFileName = datPath + String("well.dat");
  HarvestProcessor->ProcessTextFile();
  WellDAT->Active = true;

  USTCProcessor->DataTableName = TerCostDAT;
  USTCProcessor->DatFileName = datPath + String("terrcost.dat");
  USTCProcessor->ProcessTextFile();
  TerCostDAT->Active = true;

  /* DONE -oMaciej : "List Index out of bounds (13)" error in USTCProcessor when loading unitspot.dat */
  USTCProcessor->DataTableName = UnitSpotDAT;
  USTCProcessor->DatFileName = datPath + String("unitspot.dat");
  USTCProcessor->ProcessTextFile();
  UnitSpotDAT->Active = true;

  return true;
}
//---------------------------------------------------------------------------

bool TGalaxyModule::SaveDATFiles(String datPath)
{
/* TODO : 
Copy DAT files not handled by Processor components from original 
(or "Basic") directory */

  ResProcessor->DataTableName = ResDAT;
  ResProcessor->DatFileName = datPath + String("res.dat");
  ResProcessor->ProcessDataBase();

  UnitProcessor->DataTableName = UnitDAT;
  UnitProcessor->DatFileName = datPath + String("unit.dat");
  UnitProcessor->ProcessDataBase();

  StrBuildProcessor->DataTableName = StructureDAT;
  StrBuildProcessor->DatFileName = datPath + String("strbuild.dat");
  StrBuildProcessor->ProcessDataBase();

  TechDatProcessor->DataTableName = TechDAT;
  TechDatProcessor->DatFileName = datPath + String("tech.dat");
  TechDatProcessor->ProcessDataBase();

  DamageProcessor->DataTableName = DamageDAT;
  DamageProcessor->DamageFileName = datPath + String("damage.dat");
  DamageProcessor->ProcessDataBase();

  TargetProcessor->DataTableName = TargetDAT;
  TargetProcessor->DatFileName = datPath + String("target.dat");
  TargetProcessor->ProcessDataBase();

  StockProcessor->DataTableName = StockDAT;
  StockProcessor->DatFileName = datPath + String("stock.dat");
  StockProcessor->ProcessDataBase();

  TerColorProcessor->DataTableName = TerColorDAT;
  TerColorProcessor->DatFileName = datPath + String("tercolor.dat");
  TerColorProcessor->ProcessDataBase();

  RoadCostProcessor->DataTableName = RoadCostDAT;
  RoadCostProcessor->DatFileName = datPath + String("roadcost.dat");
  RoadCostProcessor->ProcessDataBase();

  ProdProcessor->DataTableName = ProdDAT;
  ProdProcessor->DatFileName = datPath + String("prod.dat");
  ProdProcessor->ProcessDataBase();

  HarvestProcessor->DataTableName = ArboriumDAT;
  HarvestProcessor->HarvestDatFileName = datPath + String("arborium.dat");
  HarvestProcessor->ProcessDataBase();

  HarvestProcessor->DataTableName = FarmDAT;
  HarvestProcessor->HarvestDatFileName = datPath + String("farm.dat");
  HarvestProcessor->ProcessDataBase();

  HarvestProcessor->DataTableName = MineDAT;
  HarvestProcessor->HarvestDatFileName = datPath + String("mine.dat");
  HarvestProcessor->ProcessDataBase();

  HarvestProcessor->DataTableName = WellDAT;
  HarvestProcessor->HarvestDatFileName = datPath + String("well.dat");
  HarvestProcessor->ProcessDataBase();

  USTCProcessor->DataTableName = TerCostDAT;
  USTCProcessor->DatFileName = datPath + String("terrcost.dat");
  USTCProcessor->ProcessDataBase();

  USTCProcessor->DataTableName = UnitSpotDAT;
  USTCProcessor->DatFileName = datPath + String("unitspot.dat");
  USTCProcessor->ProcessDataBase();

  ActivateAllTables();

  return true;

}
//---------------------------------------------------------------------------

void TGalaxyModule::CreateProject(String projectAlias)
{
  DeactivateAllTables();

  SetDatabase(projectAlias);
  
  // Create empty tables for each distinct physical table in the
  //project database (but only if Tag in non-zero):
  for (int i=0; i<ComponentCount; i++) {
    TTable* C = dynamic_cast<TTable*>(Components[i]);
    if (C) {
      if (C->Tag) {
        C->CreateTable();
      }
    }
  }

  ActivateAllTables();
  FilterDataSets(false);
  DeactivateAllTables();

}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------


