//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TNewGalaxyModule.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "StrBuildProcessor"
#pragma link "TBasicGalaxyModule"
#pragma link "TechDatProcessor"
#pragma link "UnitProcessor"
#pragma resource "*.dfm"
TNewGalaxyModule *NewGalaxyModule;
//---------------------------------------------------------------------------
__fastcall TNewGalaxyModule::TNewGalaxyModule(TComponent* Owner)
  : TBasicGalaxyModule(Owner)
{
  ActivateAllTables();  
}
//---------------------------------------------------------------------------
void __fastcall TNewGalaxyModule::UnitTableCalcFields(TDataSet *DataSet)
{
  switch (UnitTableExperience->AsInteger)
  {
    case 0 : UnitTableExpText->AsString = "Gr";
    break;
    case 1 : UnitTableExpText->AsString = "Ex";
    break;
    case 2 : UnitTableExpText->AsString = "El";
    break;
  }
}
//---------------------------------------------------------------------------

void TNewGalaxyModule::ActivateAllTables()
{
  for (int i=0; i<ComponentCount; i++) {
    TTable* C = dynamic_cast<TTable*>(Components[i]);
    if (C) {
      C->Active = true;
    }
  }
}
//---------------------------------------------------------------------------

void TNewGalaxyModule::DeactivateAllTables()
{
  for (int i=0; i<ComponentCount; i++) {
    TTable* C = dynamic_cast<TTable*>(Components[i]);
    if (C) {
      C->Active = false;
    }
  }
}
//---------------------------------------------------------------------------

void TNewGalaxyModule::SetDatabase(String aliasName)
{
  for (int i=0; i<ComponentCount; i++) {
    TDBDataSet* C = dynamic_cast<TDBDataSet*>(Components[i]);
    if (C) {
      bool WasActive = C->Active;
      C->Active = false;
      C->DatabaseName = aliasName;
      C->Active = WasActive;
    }
  }
}
//---------------------------------------------------------------------------

TNewGalaxyModule::FilterDataSets(bool filtered)
{
  for (int i=0; i<ComponentCount; i++) {
    TBDEDataSet* C = dynamic_cast<TBDEDataSet*>(Components[i]);
    if (C) {
      C->Filtered = filtered;
    }
  }
}
//---------------------------------------------------------------------------

bool TNewGalaxyModule::LoadDATFiles(String datPath)
{
  UnitProcessor->DataTableName = UnitDAT;
  UnitProcessor->UnitDatFileName = datPath + String("unit.dat");
  UnitProcessor->ProcessTextFile();
  UnitDAT->Active = true;
  // The following is technically no longer needed since the 'ID' field of
  //UnitDat.db is now calculated this way by TUnitProcessor...
  UnitDAT->First();
  while (!UnitDAT->Eof) {
    UnitDAT->Edit();
    UnitDATTTL->AsInteger = UnitDATType->AsInteger * 10 + UnitDATTLvl->AsInteger;
    UnitDAT->Next();
  }
  UnitDAT->First();

  StrBuildProcessor->DataTableName = StructureDAT;
  StrBuildProcessor->StrBuildFileName = datPath + String("strbuild.dat");
  StrBuildProcessor->ProcessTextFile();
  StructureDAT->Active = true;

  TechDatProcessor->DataTableName = TechDAT;
  TechDatProcessor->TechDatFileName = datPath + String("tech.dat");
  TechDatProcessor->ProcessTextFile();
  TechDAT->Active = true;

  return true;
}
//---------------------------------------------------------------------------

void TNewGalaxyModule::CreateProject(String projectAlias)
{
  ActivateAllTables();
  FilterDataSets(false);
  DeactivateAllTables();
  SetDatabase(projectAlias);

  // Create empty tables for each distinct physical table in the
  //project database:
  FactionTable->CreateTable();
  SectTable->CreateTable();
  PlanetType->CreateTable();
  PlanetTable->CreateTable();
  JumpRouteTable->CreateTable();
  UnitTable->CreateTable();
  StructureTable->CreateTable();
  UnitDAT->CreateTable();
  StructureDAT->CreateTable();
  StructureDAT->CreateTable();

}
//---------------------------------------------------------------------------

