//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TUnitListView.h"
#include "TGalaxyModule.h"
#include "TEditUnitTypeDialog.h"
#include "TEFSMain.h"
#include "TEditUnitStatsDialog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TUnitListView *UnitListView;
//---------------------------------------------------------------------------
__fastcall TUnitListView::TUnitListView(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TUnitListView::FormClose(TObject *Sender, TCloseAction &Action)
{
  Action = caFree;
  UnitListView = NULL;
}
//---------------------------------------------------------------------------

void __fastcall TUnitListView::SwapUnitTypesActionExecute(TObject *Sender)
{
  //TBookmark SavePos;
  //SavePos = GalaxyModule->EditUnitsTable->GetBookmark();
  bool SaveFilterOnUnitType = cbShowUnitsOfType->Checked;
  if (!cbShowUnitsOfType->Checked) {
    cbShowUnitsOfType->Checked = true;
    UpdateView();
  }
  int result = EditUnitTypeDialog->ShowModal();
  if (result == mrOk) {
    cbType->KeyValue = EditUnitTypeDialog->cbNUT->KeyValue;
    //GalaxyModule->EditUnitsTable->GotoBookmark(SavePos);
  }
  //GalaxyModule->EditUnitsTable->FreeBookmark(SavePos);
  cbShowUnitsOfType->Checked = SaveFilterOnUnitType;
  UpdateView();
}
//---------------------------------------------------------------------------

void __fastcall TUnitListView::FormShow(TObject *Sender)
{
  cbFaction->KeyValue = 0;
  cbPlanet->KeyValue = 0;
  cbType->KeyValue = 0;
}
//---------------------------------------------------------------------------

void TUnitListView::UpdateView()
{
  String filter = "";
  if (cbShowUnitsOfFaction->Checked) {
    filter = filter + String("Owner = ") + cbFaction->KeyValue;
  }
  if (cbShowUnitsOnPlanet->Checked) {
    if (filter == "") filter = filter + String("PIdx = ") + cbPlanet->KeyValue;
    else filter = filter + String(" and PIdx = ") + cbPlanet->KeyValue;
  }
  if (cbShowUnitsOfType->Checked) {
    if (filter == "") filter = filter + String("TTL = ") + cbType->KeyValue;
    else filter = filter + String(" and TTL = ") + cbType->KeyValue;
  }

  if (filter != "") {
    GalaxyModule->UnitTable->Filter = filter;
    GalaxyModule->UnitTable->Filtered = true;
  }
  else {
    GalaxyModule->UnitTable->Filter = String("");
    GalaxyModule->UnitTable->Filtered = false;
  }
}
//---------------------------------------------------------------------------

void __fastcall TUnitListView::cbShowUnitsOfFactionClick(TObject *Sender)
{
  UpdateView();
}
//---------------------------------------------------------------------------

void __fastcall TUnitListView::EditUnitStatsActionExecute(TObject *Sender)
{
  int result = EditUnitStatsDialog->ShowModal();
}
//---------------------------------------------------------------------------

